/*************************************/
/* FILENAME:    config.h             */
/* VERSION:     1.5                  */
/* AUTHOR:      KRZYSZTOF GAJ        */
/* LAST CHANGE: 8 JULY 1992          */
/*************************************/


/*** LIST OF VALID CONFIGURATION VARIABLES ***/

/* list of valid configuration variables i.e., such variables
    which names can appear in the configuration file - hs.config;

    constants corresponding to each element of the list
    are given below;
    any change on this list should be followed by a change
    of corresponding constants;
*/


static char *config_item_list[]=
              {
               "PULSE_EXTRACTION_METHOD",
               "PHASE_THRESHOLD_NOM",
               "PHASE_THRESHOLD_MIN",
               "PHASE_THRESHOLD_MAX",
               "TIME_INTERPOLATION",
               "VOLTAGE_THRESHOLD",
               "MINIMUM_PHASE_DIFFERENCE",
               "CHECKPOINT_RATIO",
               "FAIL_THRESHOLD",
               "INPUT_DIRECTORY",
               "TMP_DIRECTORY",
               "OUTPUT_DIRECTORY",
               "SPICE_CALL_NAME",
               "CIRCUIT_EXTENSION",
               "NOMINAL_PARAMETERS_EXTENSION",
               "PRINT_EXTENSION",
               "STEP_EXTENSION",
               "CHECKPOINTS_EXTENSION",
               "PHASE_EXTENSION",
               "SETUP_EXTENSION",
               "HOLD_EXTENSION",
               "PASS_EXTENSION",
               "FAIL_EXTENSION",
               "LOGIC_EXTENSION",
               "HOLDSETUP_EXTENSION",
               "REPORT_EXTENSION",
               "MID_EXTENSION",
               "BINSEARCH_ACCURACY",
               "INPUTS_CHECKED",
               "MAX_DELAY_VARIATION",
               "MIN_TIME_STEP",
               "NOMINAL_EXTENSION",
               "INIT_EXTENSION",
               "PASSFAIL_EXTENSION",
	       "MARGINS_EXTENSION",
	       "BOUNDARY_EXTENSION",
	       "OPTIMIZATION_EXTENSION",
	       "REGION_EXTENSION",
               "SEPARATION_EXTENSION",
               "MAX_PLANE",
               "MAX_ITER",
               "MIN_ITER",
               "TIMING_SEARCH_ACCURACY",
	       "SIGNAL_EXTENSION",
	       "THRESHOLD_LEVEL",
	       "MAX_ZERO_LEVEL",
               "MIN_ONE_LEVEL",
               "INTERVAL_BETWEEN_CHECKPOINTS",
               "RISING_EDGE_CHECKPOINT_INTERVAL",
	       "FALLING_EDGE_CHECKPOINT_INTERVAL",
               "MIN_INTEREDGE_INTERVAL",
               "CLOCK_CHECKTIME_RATIO",
               "AVR_ONE_VOLTAGE"
              };

#define CONFIG_ITEM_NUM (sizeof(config_item_list)/sizeof(char *))

/*
  The following codes describe the position
  of an appropriate item in a table
  <config_item_list>.
*/

#define PLS_EXTR_MTHD_CONFIG  	0
#define PH_THR_NOM_CONFIG 	1
#define PH_THR_MIN_CONFIG	2
#define PH_THR_MAX_CONFIG	3
#define INTERPOL_CONFIG    	4
#define VOLT_THR_CONFIG		5
#define MIN_PH_DIFF_CONFIG   	6
#define CHECK_RATIO_CONFIG	7
#define FAIL_THR_CONFIG		8
#define IN_CONFIG 		9
#define TMP_CONFIG		10
#define OUT_CONFIG		11
#define SPICE_CONFIG 		12
#define CIRC_CONFIG		13
#define PARAM_CONFIG		14
#define PRINT_CONFIG		15
#define STEP_CONFIG		16
#define CHECK_CONFIG		17
#define PHASE_CONFIG 		18
#define SETUP_CONFIG		19
#define HOLD_CONFIG 		20
#define GOOD_CONFIG		21
#define BAD_CONFIG		22
#define LOGIC_CONFIG		23
#define HOSE_CONFIG 		24
#define REPORT_CONFIG		25
#define MID_CONFIG		26
#define ACCURACY_CONFIG		27
#define IN_CHECK_CONFIG		28
#define MAX_DEL_VAR_CONFIG	29
#define MIN_TIME_STEP_CONFIG	30
#define NOMINAL_CONFIG		31
#define INIT_CONFIG		32
#define PASSFAIL_CONFIG		33
#define MARGINS_CONFIG		34
#define BOUNDARY_CONFIG		35
#define OPTIMIZE_CONFIG		36
#define REGION_CONFIG		37
#define SEPARATION_CONFIG	38
#define MAXPLANE_CONFIG	        39
#define MAXITER_CONFIG          40
#define MINITER_CONFIG          41
#define TIME_ACCURACY_CONFIG    42
#define SIGNAL_CONFIG		43
#define THRESHOLD_CONFIG	44
#define MAX_ZERO_CONFIG	        45
#define MIN_ONE_CONFIG     	46
#define CHECK_INT_CONFIG        47
#define RISEEDGE_CHECK_INT_CONFIG   48
#define FALLEDGE_CHECK_INT_CONFIG   49
#define INTEREDGE_INT_CONFIG    50
#define CLK_CHECKTIME_CONFIG    51
#define ONE_VOLTAGE_CONFIG      52


static char *xy_config_item_list[]=
       {
        "MIN_DELAY",
	"MAX_DELAY",
	"SIMULATION_STEP",
	"INPUT_NR",
        "IN_CLK_CYCLE_NR",
        "OUT_CLK_CYCLE_NR"
       };

#define XY_CONFIG_ITEM_NUM (sizeof(xy_config_item_list)/sizeof(char *))


#define XMIN_XY_CONFIG           0
#define XMAX_XY_CONFIG		(XMIN_XY_CONFIG+1)
#define XSTEP_XY_CONFIG		(XMAX_XY_CONFIG+1)
#define INPUT_NR_XY_CONFIG	(XSTEP_XY_CONFIG+1)
#define IN_CLK_CYCLE_XY_CONFIG	(INPUT_NR_XY_CONFIG+1)
#define OUT_CLK_CYCLE_XY_CONFIG	(IN_CLK_CYCLE_XY_CONFIG+1)
